
int ledPin = 9; //LED op PB1
int OnOffPin = 8; //on off to PB0
int rot_aPin = 2; //pin A from rotary encoder
int rot_bPin = 4; //pin B from rotary encoder
int rot_switch = 3; // switch from rotary encoder
volatile uint8_t count_rotate, ledVal;
volatile bool rotated, rotate_right, switched, On_Off;
ISR (INT0_vect)
{
  rotate_right = (PIND & _BV(PORTD4)); //bool is true for rotate right
  rotated = true;
}

ISR (INT1_vect)
{
  switched = true;
}

void setup() {
  pinMode(rot_aPin, INPUT_PULLUP);
  pinMode(rot_bPin, INPUT_PULLUP);
  pinMode(rot_switch, INPUT_PULLUP);
  pinMode(ledPin, OUTPUT);
  pinMode(OnOffPin, OUTPUT);
  digitalWrite(OnOffPin, false);
  analogWrite(ledPin, 255);
  EICRA |= ((1 << ISC01) | (1 << ISC11));  // set INT to trigger on falling edge
  EIMSK |= ((1 << INT0) | (1 << INT1));   // Turns on INT0 (interrupt from PD2,3)
  Serial.begin(31250);
  On_Off = true;
  switched = true;
  sei();
}

void loop() {
  while (1) {
    if (switched)
    {
      if (On_Off) {// use the MainMute
        analogWrite(ledPin, 0);//stop the dimmer of GREEN
        digitalWrite(OnOffPin, true);//LED goes RED
        On_Off = false;
        Serial.print(char(0xB1));
        Serial.print(char(0x1F));
        Serial.print(char(0x7F));//max mute
      }
      else {
        analogWrite(ledPin, ledVal);//enable the GREEN dimmer
        digitalWrite(OnOffPin, false);//LED goed GREEN
        On_Off = true;
        Serial.print(char(0xB1));
        Serial.print(char(0x1F));
        Serial.print(char(0x00));//mute is off
      }
      while (!(PIND & _BV(PORTD3)));//until switch is released;
      switched = false;
    }
    if (rotated)
    {
      rotated = false;
      if (On_Off) //if true, use the MainFader
      {
        if (rotate_right) {
          if (ledVal <= 253) {
            ledVal += 2;
          }
        }
        if (!(rotate_right)) {
          if (ledVal >= 2) {
            ledVal -= 2;
          }
        }
        analogWrite(ledPin, ledVal);//dim the GREEN LED accordingly
        Serial.print(char(0xB0));
        Serial.print(char(0x1F));
        Serial.print(char(ledVal >> 1)); // set the Main Fader between 0 - 127
      }
    }
  }
}
